/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.thalesgroup.parameters;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.thalesgroup.parameters.ParametersFactory
 * @model kind="package"
 * @generated
 */
public interface ParametersPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "parameters";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.thalesgroup.com/parameters/1.0";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "com.thalesgroup.parameters.model";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ParametersPackage eINSTANCE = com.thalesgroup.parameters.impl.ParametersPackageImpl.init();

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.ParameterSetImpl <em>Parameter Set</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.ParameterSetImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getParameterSet()
   * @generated
   */
  int PARAMETER_SET = 0;

  /**
   * The feature id for the '<em><b>Owned Parameters</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PARAMETER_SET__OWNED_PARAMETERS = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PARAMETER_SET__NAME = 1;

  /**
   * The number of structural features of the '<em>Parameter Set</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PARAMETER_SET_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.GenericParameterImpl <em>Generic Parameter</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.GenericParameterImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getGenericParameter()
   * @generated
   */
  int GENERIC_PARAMETER = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GENERIC_PARAMETER__NAME = 0;

  /**
   * The number of structural features of the '<em>Generic Parameter</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GENERIC_PARAMETER_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.BoolParameterValueImpl <em>Bool Parameter Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.BoolParameterValueImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getBoolParameterValue()
   * @generated
   */
  int BOOL_PARAMETER_VALUE = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BOOL_PARAMETER_VALUE__NAME = GENERIC_PARAMETER__NAME;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BOOL_PARAMETER_VALUE__VALUE = GENERIC_PARAMETER_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Bool Parameter Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BOOL_PARAMETER_VALUE_FEATURE_COUNT = GENERIC_PARAMETER_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.DoubleParameterValueImpl <em>Double Parameter Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.DoubleParameterValueImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getDoubleParameterValue()
   * @generated
   */
  int DOUBLE_PARAMETER_VALUE = 3;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOUBLE_PARAMETER_VALUE__NAME = GENERIC_PARAMETER__NAME;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOUBLE_PARAMETER_VALUE__VALUE = GENERIC_PARAMETER_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Double Parameter Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DOUBLE_PARAMETER_VALUE_FEATURE_COUNT = GENERIC_PARAMETER_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.StringParameterValueImpl <em>String Parameter Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.StringParameterValueImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getStringParameterValue()
   * @generated
   */
  int STRING_PARAMETER_VALUE = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STRING_PARAMETER_VALUE__NAME = GENERIC_PARAMETER__NAME;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STRING_PARAMETER_VALUE__VALUE = GENERIC_PARAMETER_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>String Parameter Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int STRING_PARAMETER_VALUE_FEATURE_COUNT = GENERIC_PARAMETER_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link com.thalesgroup.parameters.impl.IntParameterValueImpl <em>Int Parameter Value</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see com.thalesgroup.parameters.impl.IntParameterValueImpl
   * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getIntParameterValue()
   * @generated
   */
  int INT_PARAMETER_VALUE = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INT_PARAMETER_VALUE__NAME = GENERIC_PARAMETER__NAME;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INT_PARAMETER_VALUE__VALUE = GENERIC_PARAMETER_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Int Parameter Value</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INT_PARAMETER_VALUE_FEATURE_COUNT = GENERIC_PARAMETER_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.ParameterSet <em>Parameter Set</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Parameter Set</em>'.
   * @see com.thalesgroup.parameters.ParameterSet
   * @generated
   */
  EClass getParameterSet();

  /**
   * Returns the meta object for the containment reference list '{@link com.thalesgroup.parameters.ParameterSet#getOwnedParameters <em>Owned Parameters</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Owned Parameters</em>'.
   * @see com.thalesgroup.parameters.ParameterSet#getOwnedParameters()
   * @see #getParameterSet()
   * @generated
   */
  EReference getParameterSet_OwnedParameters();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.ParameterSet#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see com.thalesgroup.parameters.ParameterSet#getName()
   * @see #getParameterSet()
   * @generated
   */
  EAttribute getParameterSet_Name();

  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.GenericParameter <em>Generic Parameter</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Generic Parameter</em>'.
   * @see com.thalesgroup.parameters.GenericParameter
   * @generated
   */
  EClass getGenericParameter();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.GenericParameter#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see com.thalesgroup.parameters.GenericParameter#getName()
   * @see #getGenericParameter()
   * @generated
   */
  EAttribute getGenericParameter_Name();

  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.BoolParameterValue <em>Bool Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Bool Parameter Value</em>'.
   * @see com.thalesgroup.parameters.BoolParameterValue
   * @generated
   */
  EClass getBoolParameterValue();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.BoolParameterValue#isValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.thalesgroup.parameters.BoolParameterValue#isValue()
   * @see #getBoolParameterValue()
   * @generated
   */
  EAttribute getBoolParameterValue_Value();

  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.DoubleParameterValue <em>Double Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Double Parameter Value</em>'.
   * @see com.thalesgroup.parameters.DoubleParameterValue
   * @generated
   */
  EClass getDoubleParameterValue();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.DoubleParameterValue#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.thalesgroup.parameters.DoubleParameterValue#getValue()
   * @see #getDoubleParameterValue()
   * @generated
   */
  EAttribute getDoubleParameterValue_Value();

  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.StringParameterValue <em>String Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>String Parameter Value</em>'.
   * @see com.thalesgroup.parameters.StringParameterValue
   * @generated
   */
  EClass getStringParameterValue();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.StringParameterValue#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.thalesgroup.parameters.StringParameterValue#getValue()
   * @see #getStringParameterValue()
   * @generated
   */
  EAttribute getStringParameterValue_Value();

  /**
   * Returns the meta object for class '{@link com.thalesgroup.parameters.IntParameterValue <em>Int Parameter Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Int Parameter Value</em>'.
   * @see com.thalesgroup.parameters.IntParameterValue
   * @generated
   */
  EClass getIntParameterValue();

  /**
   * Returns the meta object for the attribute '{@link com.thalesgroup.parameters.IntParameterValue#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see com.thalesgroup.parameters.IntParameterValue#getValue()
   * @see #getIntParameterValue()
   * @generated
   */
  EAttribute getIntParameterValue_Value();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ParametersFactory getParametersFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.ParameterSetImpl <em>Parameter Set</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.ParameterSetImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getParameterSet()
     * @generated
     */
    EClass PARAMETER_SET = eINSTANCE.getParameterSet();

    /**
     * The meta object literal for the '<em><b>Owned Parameters</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PARAMETER_SET__OWNED_PARAMETERS = eINSTANCE.getParameterSet_OwnedParameters();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PARAMETER_SET__NAME = eINSTANCE.getParameterSet_Name();

    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.GenericParameterImpl <em>Generic Parameter</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.GenericParameterImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getGenericParameter()
     * @generated
     */
    EClass GENERIC_PARAMETER = eINSTANCE.getGenericParameter();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute GENERIC_PARAMETER__NAME = eINSTANCE.getGenericParameter_Name();

    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.BoolParameterValueImpl <em>Bool Parameter Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.BoolParameterValueImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getBoolParameterValue()
     * @generated
     */
    EClass BOOL_PARAMETER_VALUE = eINSTANCE.getBoolParameterValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BOOL_PARAMETER_VALUE__VALUE = eINSTANCE.getBoolParameterValue_Value();

    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.DoubleParameterValueImpl <em>Double Parameter Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.DoubleParameterValueImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getDoubleParameterValue()
     * @generated
     */
    EClass DOUBLE_PARAMETER_VALUE = eINSTANCE.getDoubleParameterValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DOUBLE_PARAMETER_VALUE__VALUE = eINSTANCE.getDoubleParameterValue_Value();

    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.StringParameterValueImpl <em>String Parameter Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.StringParameterValueImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getStringParameterValue()
     * @generated
     */
    EClass STRING_PARAMETER_VALUE = eINSTANCE.getStringParameterValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute STRING_PARAMETER_VALUE__VALUE = eINSTANCE.getStringParameterValue_Value();

    /**
     * The meta object literal for the '{@link com.thalesgroup.parameters.impl.IntParameterValueImpl <em>Int Parameter Value</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.thalesgroup.parameters.impl.IntParameterValueImpl
     * @see com.thalesgroup.parameters.impl.ParametersPackageImpl#getIntParameterValue()
     * @generated
     */
    EClass INT_PARAMETER_VALUE = eINSTANCE.getIntParameterValue();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INT_PARAMETER_VALUE__VALUE = eINSTANCE.getIntParameterValue_Value();

  }

} //ParametersPackage
